export class MoneyTypeConst {
    /**
     * coin: 金币
     */
    public static readonly COIN = 'coin';
    /**
     * diamond: 钻石
     */
    public static readonly DIAMOND = 'diamond';
    /**
     * hero_shard: 通用英雄碎片
     */
    public static readonly HERO_SHARD = 'hero_shard';
    /**
     * hero_exp: 通用英雄经验
     */
    public static readonly HERO_EXP = 'hero_exp';
    /**
     * card_scroll: 抽卡卷轴
     */
    public static readonly CARD_SCROLL = 'card_scroll';

    /**
     * 英雄专用碎片
     * @param heroId
     */
    public static getHeroShard(heroId: number): string {
        return `${this.HERO_SHARD}_${heroId}`;
    }

    /**
     * 英雄专用经验
     * @param heroId
     */
    public static getHeroExp(heroId: number): string {
        return `${this.HERO_EXP}_${heroId}`;
    }

    /**
     * 检查货币字符串是否符合规则
     * @param type
     */
    public static checkMoney(type: string): boolean {
        return this.COIN == type
            || this.DIAMOND == type
            || this.CARD_SCROLL == type
            || type.indexOf(this.HERO_SHARD) == 0
            || type.indexOf(this.HERO_EXP) == 0
    }
    public static isHeroMoney(type: string): boolean {
        return type.indexOf(this.HERO_SHARD + '_') >= 0
            || type.indexOf(this.HERO_EXP + '_') >= 0
    }
    /**
     * 获取英雄专用货币中的heroid
     * @param type
     */
    public static getHeroId(type: string): number {
        if (type.indexOf(this.HERO_SHARD + '_') >= 0) {
            let str = type.substring(type.lastIndexOf('_') + 1)
            if (str) {
                return parseInt(str);
            } else {
                return 0;
            }
        } else if (type.indexOf(this.HERO_EXP+ '_') >= 0) {
            let str = type.substring(type.lastIndexOf('_') + 1)
            if (str) {
                return parseInt(str);
            } else {
                return 0;
            }
        }
        return 0;
    }
}
