import BaseController from "../common/base.controller";
import {role, router} from "../decorators/router";
import {User} from "../models/User";
import {ZError} from "../common/ZError";
import {Card} from "../models/subdoc/Card";

export default class AccountController extends BaseController {
    @role('anon')
    @router('post /api/:accountid/uinfo')
    async info(req: any) {
        let {accountid} = req.params;
        let account = (await User.findOrCreate({_id: accountid})).doc;
        let result: any = {accountid: account.id};
        if (account.locked) {
            throw new ZError(4, 'account locked');
        }
        result.cards = account.cards;
        let heros: any[] = [];
        for(let [key, hero] of account.heros) {
            heros.push(hero.toJson());
        }
        result.heros = heros;
        await account.save();
        result.moneys = account.moneys;
        result.normal_stat= account.normal_stat;
        result.season_stat = account.season_stat;
        result.extinfo = account.extinfo;
        result.rank = 0;
        return result;
    }

    @router('post /api/:accountid/cards')
    async cardlist(req: any) {
        let account = req.user;
        let result: Card[] = [];
        for (let cardid of account.cards) {
            let card = new Card();
            card.cardid = cardid;
            card.owned = true;
            card.ban = false;
            card.usetype = 0;
            card.free = false;
            result.push(card);
        }
        //TODO:: 添加限免英雄和免费英雄
        return result;
    }


}
