import BaseController from "../common/base.controller";
import {router} from "../decorators/router";
import {ZError} from "../common/ZError";

export default class HeroController extends BaseController {
    @router('post /api/:accountid/heros')
    async herolist(req: any) {
        let account = req.user;
        let heros: any[] = [];
        for(let [key, hero] of account.heros) {
            heros.push(hero.toJson());
        }
        //TODO:: 添加限免英雄和免费英雄
        return heros;
    }

    @router('post /api/:accountid/hero/unlock/:heroid')
    async unlockHero(req: any) {
        let account = req.user;
        let {heroid, type} = req.params;
        if (!heroid) {
            throw new ZError(101, '未指定heroid');
        }
        let hero;
        if (!type) {
            hero = await account.unlockHero(heroid);
            await account.save();
        } else {
            hero = await account.tryHero(heroid);
            await account.save();

        }
        return hero.toJson();

    }

    @router('post /api/:accountid/hero/update/:heroid')
    async updateHero(req: any) {
        let account = req.user;
        let {heroid, items} = req.params;
        if (!heroid || !items) {
            throw new ZError(101, '参数不足');
        }
        if (!account.heros.has(heroid + '')) {
            throw new ZError(102, '你未解锁该英雄');
        }
        let hero = account.heros.get(heroid + '');
        if (hero.trial) {
            throw new ZError(103, '不能升级试用英雄');
        }
        let data = await account.updateHero(heroid, items);
        await account.save();
        return data;
    }

}
