import {mongoose} from "@typegoose/typegoose";
import {Config} from "../cfg/Config";
/**
 * 为model指定数据库连接
 * @param {string} name 数据库连接名字， 在config中必须要有对应的配置， 比如main， 则必须要有 db_main
 * */
let config: Config = require('../../config/config.json');
export function dbconn(name?: string) {
    return (target: any) => {
        name = name || 'main';
        // @ts-ignore
        const url = config['db_'+name];
        target['db'] = mongoose.createConnection(url, {
            useNewUrlParser: true,
            useCreateIndex:true,
            useFindAndModify: false,
            useUnifiedTopology: true});
    };
}
