import {dbconn} from "../decorators/dbconn";
import {
    getModelForClass,
    index,
    modelOptions,
    prop
} from "@typegoose/typegoose";
import {Base, TimeStamps} from "@typegoose/typegoose/lib/defaultClasses";

interface GameRecordClass extends Base<string>, TimeStamps {
}

/**
 * 对战记录
 */
@dbconn()
@index({accountid: 1}, {unique: false})
@modelOptions({
    schemaOptions:
        {collection: "game_record", timestamps: true}
})
class GameRecordClass {
    @prop()
    public accountid: string;

    toJson() {
        return {
            accountid: this.accountid,
        }
    }
}


export const GameRecord = getModelForClass(GameRecordClass,
    // @ts-ignore
    {existingConnection: GameRecordClass['db']})
