import {prop} from "@typegoose/typegoose";

/**
 * 卡牌信息
 */
export class Card {
    @prop()
    public cardid: number;
    /**
     * 是否已拥有
     */
    @prop()
    public owned: boolean;
    /**
     * 是否被禁
     */
    @prop({default: false})
    public ban: boolean;
    /**
     * 赛季类型
     * 0: 通用, 1: 赛季排位专用, 2: 匹配专用
     */
    @prop({default: 0})
    public usetype: number;
    /**
     * 是否是限免卡牌
     */
    @prop({default: false})
    public free: boolean;
    /**
     * 限免过期时间
     */
    @prop()
    public free_expire: number;

    public toJson() {
        return {
            cardid: this.cardid,
            owned: this.owned,
            ban: this.ban,
            usetype: this.usetype,
            free: this.free,
            free_expire: this.free_expire
        }
    }
}
